
; VCPU - Compiler dll Include

; EnableExplicit

CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x86
  CompilerError "x86 only" 
  End  
CompilerEndIf
  
PrototypeC.l BCCompiler_GetLastError()
PrototypeC.l BCCompiler_LoadSource(Source$)
PrototypeC.l BCCompiler_LoadSourceFile(File$)
PrototypeC.l BCCompiler_OptimizeCommands(Optimizations)
PrototypeC.l BCCompiler_CompileToMem(*MemSize.Long)
PrototypeC.l BCCompiler_CompileToFile(File$)

Global bcc_hLib = OpenLibrary(#PB_Any, GetPathPart(ProgramFilename())+"vcpu_compiler.dll")

If bcc_hLib
  Global _BCCompiler_GetLastError.BCCompiler_GetLastError = GetFunction(bcc_hLib, "BCCompiler_GetLastError")
  Global BCCompiler_LoadSource.BCCompiler_LoadSource = GetFunction(bcc_hLib, "BCCompiler_LoadSource")
  Global BCCompiler_LoadSourceFile.BCCompiler_LoadSourceFile = GetFunction(bcc_hLib, "BCCompiler_LoadSourceFile")
  Global BCCompiler_OptimizeCommands.BCCompiler_OptimizeCommands = GetFunction(bcc_hLib, "BCCompiler_OptimizeCommands")
  Global BCCompiler_CompileToMem.BCCompiler_CompileToMem = GetFunction(bcc_hLib, "BCCompiler_CompileToMem")
  Global BCCompiler_CompileToFile.BCCompiler_CompileToFile = GetFunction(bcc_hLib, "BCCompiler_CompileToFile")
EndIf

Macro BCCompiler_GetLastError()s
  PeekS(_BCCompiler_GetLastError())
EndMacro